package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.Constant;
import org.spongepowered.asm.mixin.injection.ModifyConstant;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.GrowthSerumEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.twisted.ExploitationEnchant;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.enchantments.ChromaticEnchant;
import dev.shadowsoffire.apotheosis.Apotheosis;
import java.util.List;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import javax.annotation.Nonnull;
import net.minecraft.world.item.ItemStack;
import javax.annotation.Nullable;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.animal.Sheep;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({ Sheep.class })
public class SheepMixin
{
    @Inject(method = { "onSheared" }, at = { @At("RETURN") }, remap = false, cancellable = true)
    public void onSheared(@Nullable final Player player, @Nonnull final ItemStack item, final Level world, final BlockPos pos, final int fortune, final CallbackInfoReturnable<List<ItemStack>> ci) {
        if (Apotheosis.enableEnch) {
            ci.setReturnValue((Object)((ChromaticEnchant)Ench.Enchantments.CHROMATIC.get()).molestSheepItems((Sheep)this, item, (List)ci.getReturnValue()));
            ci.setReturnValue((Object)((ExploitationEnchant)Ench.Enchantments.EXPLOITATION.get()).molestSheepItems((Sheep)this, item, (List)ci.getReturnValue()));
            ((GrowthSerumEnchant)Ench.Enchantments.GROWTH_SERUM.get()).unshear((Sheep)this, item);
        }
    }
    
    @ModifyConstant(method = { "onSheared" }, constant = { @Constant(intValue = 3) }, remap = false)
    public int onSheared(final int oldVal, @Nullable final Player player, @Nonnull final ItemStack item, final Level world, final BlockPos pos, final int fortune) {
        return oldVal + fortune * 2;
    }
}
